# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-06

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.AddVariable
import SEAScope.API.Command

import SEAScope.types.renderable_id
import SEAScope.types.variable

logger = logging.getLogger(__name__)


def serialize(builder, target, var_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, _variable = SEAScope.types.variable.serialize(builder, var_obj)
    _, _rid = SEAScope.types.renderable_id.serialize(builder, target)

    cls = SEAScope.API.AddVariable
    cls.AddVariableStart(builder)
    cls.AddVariableAddCollectionId(builder, _rid)
    cls.AddVariableAddVariable(builder, _variable)
    cmd_args = cls.AddVariableEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().addVariable
    args_type = SEAScope.API.CommandArgs.CommandArgs().AddVariable
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
