# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-11-04

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.GetCataloguesResponse
import SEAScope.types.source

logger = logging.getLogger(__name__)


def serialize(builder):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    opcode = SEAScope.API.OpCode.OpCode().getCatalogues
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    cls = SEAScope.API.GetCataloguesResponse.GetCataloguesResponse
    res = cls.GetRootAsGetCataloguesResponse(buf, 0)

    result = {'sources': [], 'collections': []}

    srcs_count = res.SourcesLength()
    for i in range(0, srcs_count):
        src = SEAScope.types.source.deserialize(res.Sources(i))
        result['sources'].append(src)

    collections_count = res.CollectionsLength()
    for i in range(0, collections_count):
        collection = SEAScope.types.collection.deserialize(res.Collections(i))
        result['collections'].append(collection)

    return result
