# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2019-03-27

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.GetVariableIdentifier
import SEAScope.API.GetVariableIdentifierResponse
import SEAScope.types.renderable_id

logger = logging.getLogger(__name__)


def serialize(builder, collection_label, variable_label):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _c_label = builder.CreateString(collection_label)
    _v_label = builder.CreateString(variable_label)

    cls = SEAScope.API.GetVariableIdentifier
    cls.GetVariableIdentifierStart(builder)
    cls.GetVariableIdentifierAddCollectionLabel(builder, _c_label)
    cls.GetVariableIdentifierAddVariableLabel(builder, _v_label)
    cmd_args = cls.GetVariableIdentifierEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().getVariableIdentifier
    args_type = SEAScope.API.CommandArgs.CommandArgs().GetVariableIdentifier
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize(buf):
    """"""
    deserializer = SEAScope.types.renderable_id.deserialize
    _api_cls = SEAScope.API.GetVariableIdentifierResponse
    cls = _api_cls.GetVariableIdentifierResponse
    res = cls.GetRootAsGetVariableIdentifierResponse(buf, 0)
    _rid = res.Id()
    rid = deserializer(_rid)
    return rid
