# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-06

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.SelectVariable
import SEAScope.API.Command

import SEAScope.types.renderable_id

logger = logging.getLogger(__name__)


def serialize(builder, target, selected, exclusive):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _, _rid = SEAScope.types.renderable_id.serialize(builder, target)

    cls = SEAScope.API.SelectVariable
    cls.SelectVariableStart(builder)
    cls.SelectVariableAddId(builder, _rid)
    cls.SelectVariableAddSelected(builder, selected)
    cls.SelectVariableAddExclusive(builder, exclusive)
    cmd_args = cls.SelectVariableEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().selectVariable
    args_type = SEAScope.API.CommandArgs.CommandArgs().SelectVariable
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
