# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.OpCode
import SEAScope.API.CommandArgs
import SEAScope.API.SetTimespan
import SEAScope.API.Command

logger = logging.getLogger(__name__)


def serialize(builder, label):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _label = builder.CreateString(label)

    cls = SEAScope.API.SetTimespan
    cls.SetTimespanStart(builder)
    cls.SetTimespanAddLabel(builder, _label)
    cmd_args = cls.SetTimespanEnd(builder)

    opcode = SEAScope.API.OpCode.OpCode().setTimespan
    args_type = SEAScope.API.CommandArgs.CommandArgs().SetTimespan
    SEAScope.API.Command.CommandStart(builder)
    SEAScope.API.Command.CommandAddOpcode(builder, opcode)
    SEAScope.API.Command.CommandAddArgsType(builder, args_type)
    SEAScope.API.Command.CommandAddArgs(builder, cmd_args)
    cmd = SEAScope.API.Command.CommandEnd(builder)

    return builder, cmd


def deserialize():
    """"""
    pass
