# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-09

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.GCP

logger = logging.getLogger(__name__)


def serialize(builder, gcp_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    cls = SEAScope.API.GCP
    gcp = cls.CreateGCP(builder,
                        gcp_obj['lon'],
                        gcp_obj['lat'],
                        int(gcp_obj['i']),
                        int(gcp_obj['j']))

    return builder, gcp


def deserialize(o):
    """"""
    result = {}
    result['lon'] = o.Lon()
    result['lat'] = o.Lat()
    result['i'] = o.I()
    result['j'] = o.J()
    return result
