# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-11-03

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.GranuleData
import SEAScope.types.data_bucket

logger = logging.getLogger(__name__)


def serialize(builder, data_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    cls = SEAScope.API.GranuleData

    _fields = []
    for field in data_obj.keys():
        _field = builder.CreateString(field)
        _fields.append(_field)
    fields_len = len(_fields)
    cls.GranuleDataStartFieldsVector(builder, fields_len)
    for _field in _fields:
        builder.PrependUOffsetTRelative(_field)
    fields = builder.EndVector(fields_len)

    _data = []
    for field in data_obj.keys():
        _, _d = SEAScope.types.data_bucket.serialize(builder, data_obj[field])
        _data.append(_d)
    cls.GranuleDataStartBucketsVector(builder, fields_len)
    for _d in _data:
        builder.PrependUOffsetTRelative(_d)
    buckets = builder.EndVector(fields_len)

    cls.GranuleDataStart(builder)
    cls.GranuleDataAddFields(builder, fields)
    cls.GranuleDataAddBuckets(builder, buckets)
    g_data = cls.GranuleDataEnd(builder)

    return builder, g_data


def deserialize(o):
    """"""
    pass
