# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-07

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.Timespan

logger = logging.getLogger(__name__)


def serialize(builder, span_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _label = builder.CreateString(span_obj['label'])
    _past = span_obj['pastOffset']
    _future = span_obj['futureOffset']
    cls = SEAScope.API.Timespan
    cls.TimespanStart(builder)
    cls.TimespanAddLabel(builder, _label)
    cls.TimespanAddPastOffset(builder, _past)
    cls.TimespanAddFutureOffset(builder, _future)
    timespan = cls.TimespanEnd(builder)

    return builder, timespan


def deserialize(o):
    """"""
    result = {}
    result['label'] = o.Label()
    result['pastOffset'] = o.PastOffset()
    result['futureOffset'] = o.FutureOffset()
    return result
