# -*- coding: utf-8 -*-

"""
@author: <sylvain.herledan@oceandatalab.com>
@date: 2016-09-08

Copyright (C) 2016-2019 OceanDataLab

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

import logging
import flatbuffers
import SEAScope.API.Timestep

logger = logging.getLogger(__name__)


def serialize(builder, step_obj):
    """"""
    if builder is None:
        builder = flatbuffers.Builder(0)

    _label = builder.CreateString(step_obj['label'])
    _step = step_obj['step']
    cls = SEAScope.API.Timestep
    cls.TimestepStart(builder)
    cls.TimestepAddLabel(builder, _label)
    cls.TimestepAddStep(builder, _step)
    timestep = cls.TimestepEnd(builder)

    return builder, timestep


def deserialize(o):
    """"""
    result = {}
    result['label'] = o.Label()
    result['step'] = o.Step()
    return result
